=== debian/changelog ===
antpm (1.24-1) unstable; urgency=medium

  [ Kristóf Ralovich ]
  * new upstream release
    - replace most boost usage with C++ 17
  * debian: simple tests for executable from the binary package
  * debian: mark self tests as superficial
  * debian: only require valgrind for building on most common architectures
    (Closes: #1100495)
  * debian/control: restrict to architecture-is-little-endian
  * debian/rules: do not fail package building if tests don't succeed
    (Closes: #1100504)
  * debian: capture verbose logs of failing tests
  * debian/control: standards version 4.7.2

 -- Kristóf Ralovich <tade60@freemail.hu>  Sun, 30 Mar 2025 09:21:46 +0200
