=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#   CFLAGS += -O2
# endif

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

NUMCPUS=$(shell grep -c '^processor' /proc/cpuinfo)
ifeq ($(NUMCPUS),0)
		NUMCPUS=1
endif
ifeq ($(NUMCPUS),)
		NUMCPUS=1
endif

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=src --builddirectory=cmake-build -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_FLAGS="${CMAKE_C_FLAGS} $(CFLAGS)" -DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS} $(CXXFLAGS)" -DUSE_BOOST_TEST=TRUE

override_dh_auto_build:
	cd cmake-build && $(MAKE) -j$(NUMCPUS) VERBOSE=true

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd cmake-build && ctest -N && ctest -j$(NUMCPUS) --rerun-failed --output-on-failure || true
endif

override_dh_auto_clean:
	dh_auto_clean
	$(RM) src/tests/config_tmp.ini
	$(RM) -r cmake-build

DESTDIR=../debian/antpm/
override_dh_install:
	cd cmake-build && $(MAKE) install DESTDIR=$(DESTDIR)
	mv debian/antpm/usr/bin/gant debian/antpm/usr/bin/antpm-garmin-ant-downloader
	cp scripts/80-ant-stick.rules debian/antpm.udev
	dh_installudev
	dh_install
