=== debian/tests/control ===
Test-Command: antpm-downloader -V
Depends: antpm
Restrictions: superficial

Tests: run-help
Depends: antpm
Restrictions: superficial
